﻿Type.registerNamespace("Dowds.Gadgets");

Dowds.Gadgets.ImageInfo = function(imageResultNode)
{
    Dowds.Gadgets.ImageInfo.initializeBase(this);
    
    this._imageResultNode = imageResultNode;    
    this._url = this._readValue("Image/ThumbnailURL");
    this._width = this._readValue("Image/ThumbnailWidth");
    this._height = this._readValue("Image/ThumbnailHeight");
    this._imageUrl = this._readValue("Image/ImageURL");
};

Dowds.Gadgets.ImageInfo.prototype = 
{
    get_url: function() { return this._url; },

    get_width: function() { return this._width; },

    get_height: function() { return this._height; },

    get_ImageUrl: function() { return this._imageUrl; },

    _readValue: function(childElementName)
    {
        var node = this._imageResultNode.selectSingleNode(childElementName);
        if(node != null)
        {
            return node.text;
        }
        return null;
    }
};

Dowds.Gadgets.ImageInfo.ParseFromDoc = function(xmlDoc)
{
    var images = [];
    var imageResultNodes = xmlDoc.getElementsByTagName("Result");

    for(var i=0; i<imageResultNodes.length; i++)
    {
        images.push(new Dowds.Gadgets.ImageInfo(imageResultNodes[i]));
    }
    
    return images;
};

Dowds.Gadgets.ImageInfo.registerClass("Dowds.Gadgets.ImageInfo");