﻿Type.registerNamespace("Dowds.Gadgets");

Dowds.Gadgets.MoviesFlyout = function()
{
    Dowds.Gadgets.MoviesFlyout.initializeBase(this);
};

Dowds.Gadgets.MoviesFlyout.prototype = 
{
    initialize: function()
    {
        Dowds.Gadgets.MoviesFlyout.callBaseMethod(this, "initialize");
    },

    reload: function(movieInfo)
    {
        this._loadUI(movieInfo);
        this._requestData(movieInfo);
    },

    _loadUI: function(movieInfo)
    {
        $get("Title").href = movieInfo.get_link();
        $get("Title").innerHTML = movieInfo.get_title();
        $get("Title").title = movieInfo.get_title();
        
        $get("ImageResults").innerHTML = "<br /><img src='Images/Icon_Spinner.gif' align='absmiddle'> Loading Images...";

        $get("Desc").innerHTML = movieInfo.get_description();

        $get("Rating").innerText = movieInfo.get_percent();
        $get("Rating").style.color = movieInfo.get_displayColor();
        
        
        $get("LocalShowtimes").onclick = function()
        {
            var postalZipCode = System.Gadget.Settings.readString("PostalZipCode");
            
            var showtimesUrl = "{0}showtimes.php?location={1}";
            var finalShowtimesUrl = String.format(showtimesUrl, movieInfo.get_link(), postalZipCode);
            window.open(finalShowtimesUrl);
        };
        
        $get("MoreImages").onclick = function()
        {
            var moreImagesUrl = "http://search.live.com/images/results.aspx?q={0} Movies"
            var finalMoreImagesUrl = String.format(moreImagesUrl, movieInfo.get_title());
            window.open(finalMoreImagesUrl);
        };
    },

    _requestData: function(movieInfo)
    {
        var searchRequestBody = '<?xml version="1.0"?>\
            <SOAP-ENV:Envelope xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/">\
                <SOAP-ENV:Body>\
                    <tns:Search xmlns:tns="http://schemas.microsoft.com/MSNSearch/2005/09/fex">\
                        <tns:Request>\
                            <tns:AppID>36C8973864EB9C43F3109DC7DAA6420669339B36</tns:AppID>\
                            <tns:Query>{0} Movie</tns:Query>\
                            <tns:CultureInfo>en-US</tns:CultureInfo>\
                            <tns:Requests>\
                                <tns:SourceRequest>\
                                    <tns:Source>Image</tns:Source>\
                                    <tns:ResultFields>Description Image Title</tns:ResultFields>\
                                </tns:SourceRequest>\
                            </tns:Requests>\
                        </tns:Request>\
                    </tns:Search>\
                </SOAP-ENV:Body>\
            </SOAP-ENV:Envelope>';
        
        var wRequest = new Sys.Net.WebRequest();
        wRequest.set_url("http://soap.search.msn.com/webservices.asmx?wsdl");
        wRequest.set_body(String.format(searchRequestBody, movieInfo.get_title()));
        wRequest.add_completed(Function.createDelegate(this, this._processData));
        wRequest.invoke();
    },

    _processData: function(executor)
    {

        if (executor.get_responseAvailable() && executor.get_xml() != null) 
        {
            var movieDoc = executor.get_xml();

            // remove the default namespace, it make it a pain to select nodes
            var namespaceFreeXml = movieDoc.xml.replace(' xmlns="http://schemas.microsoft.com/MSNSearch/2005/09/fex"', "");
            movieDoc.loadXML(namespaceFreeXml);

            var images = Dowds.Gadgets.ImageInfo.ParseFromDoc(movieDoc);
            this._bindTable(images);
        }
        else
        {
            $get("ImageResults").innerHTML = "<br /><img src='Images/Icon_Info.png' align='absmiddle'> Images are currentally unavable.";
        }
    },
    
    _bindTable: function(images)
    {
        $get("ImageResults").innerHTML = '<table>\
            <tr>\
                <td id="Image1"><a><img /></a></td>\
                <td id="Image2"><a><img /></a></td>\
                <td id="Image3"><a><img /></a></td>\
            </tr>\
            <tr>\
                <td id="Image4"><a><img /></a></td>\
                <td id="Image5"><a><img /></a></td>\
                <td id="Image6"><a><img /></a></td>\
            </tr>\
        </table>';

        for(var i=0; (i<6 && i<images.length); i++)
        {
            var imageDiv = document.getElementById("Image" + (i+1));
            var image = imageDiv.firstChild.firstChild;
            var imageInfo = images[i];
            
            image.style.visibility = "visible";

            image.src = imageInfo.get_url();
            
            image.height = (imageInfo.get_height()/3);
            image.width = (imageInfo.get_width()/3);
            
            var hyperlink = imageDiv.firstChild;
            hyperlink.href = imageInfo.get_ImageUrl();
        }
    }
}

Dowds.Gadgets.MoviesFlyout.registerClass("Dowds.Gadgets.MoviesFlyout", Sys.Component);

//////////////////////////////////////////////////////

var moviesFlyout;
window.onload = function()
{
    moviesFlyout = $create(Dowds.Gadgets.MoviesFlyout);
};