﻿Type.registerNamespace("Dowds.Gadgets");

Dowds.Gadgets.MoviesSettings = function()
{
    Dowds.Gadgets.MoviesSettings.initializeBase(this);
};

Dowds.Gadgets.MoviesSettings.prototype = 
{
    initialize: function()
    {
        System.Gadget.onSettingsClosing = this._settingsClosing;
        
        var dataSource = $get("DataSource");

        var dataSourceUrl = System.Gadget.Settings.readString("DataSourceUrl");
        if(dataSourceUrl)
        {
            dataSource.value = dataSourceUrl;
        }

        $get("PostalZipCode").value = System.Gadget.Settings.readString("PostalZipCode");
    },
    
    _settingsClosing: function(event)
    {
        if (event.closeAction == event.Action.commit)
        {
            var dataSource = $get("DataSource");
            System.Gadget.Settings.writeString("DataSourceUrl", dataSource.value);
            System.Gadget.Settings.writeString("DataSourceName", dataSource.options[dataSource.selectedIndex].text);

            var postalZipCodeValue = $get("PostalZipCode").value;
            System.Gadget.Settings.writeString("PostalZipCode", postalZipCodeValue);
        }
        event.cancel = false;
    }
}

Dowds.Gadgets.MoviesSettings.registerClass("Dowds.Gadgets.MoviesSettings", Sys.Component);

//////////////////////////////////////////////////////

var moviesSettings
window.onload = function()
{
    moviesSettings = $create(Dowds.Gadgets.MoviesSettings);
};